using System;
using System.Web;
using System.Collections;
using System.Web;

namespace Imf.Cart.CartAppCode
{

	/// <summary>
	/// Summary description for Utility
	/// </summary>
	public class Root
	{
		public static void CleanCache()
		{
			//remove all cached objects
			IDictionaryEnumerator en = HttpContext.Current.Cache.GetEnumerator();
			while (en.MoveNext())
			{
				HttpContext.Current.Cache.Remove(en.Key + "");
			}
		}

		private static string strSiteRoot = null;

		public static string GetSiteRoot()
		{
			if (strSiteRoot != null)
			{
				return strSiteRoot;
			}

			string Port = System.Web.HttpContext.Current.Request.ServerVariables["SERVER_PORT"];
			if (Port == null || Port == "80" || Port == "443")
				Port = "";
			else
				Port = ":" + Port;

			string Protocol = System.Web.HttpContext.Current.Request.ServerVariables["SERVER_PORT_SECURE"];
			if (Protocol == null || Protocol == "0")
				Protocol = "http://";
			else
				Protocol = "https://";

			string sOut = Protocol + System.Web.HttpContext.Current.Request.ServerVariables["SERVER_NAME"] +
				Port + System.Web.HttpContext.Current.Request.ApplicationPath;
			int index = sOut.Length - 1;
			if (sOut[index] == '/')
			{
				sOut = sOut.Remove(index);
			}
			strSiteRoot = sOut;
			return strSiteRoot;
		}



		// catch data from payment gateway
		public static void SaveDiagnostic(string gatewayName)
		{

			string vals = "";
			vals += "\r\n";

			vals += "Received: \t " + DateTime.Now;

			vals += "\r\n\r\n\r\n";

			string[] keys = HttpContext.Current.Request.Form.AllKeys;
			foreach (string key in keys)
			{
				vals += key + ": \t " + HttpContext.Current.Request.Form[key] + "\r\n";
			}

			vals += "\r\n\r\n\r\n";

			vals += "User host IP: \t " + HttpContext.Current.Request.UserHostAddress;

			vals += "\r\n\r\n\r\n";

			vals += "Referer: \t " + HttpContext.Current.Request.UrlReferrer;

			vals += "\r\n\r\n\r\n";

			vals += "UserAgent: \t " + HttpContext.Current.Request.UserAgent;


			vals += "\r\n\r\n\r\n";

			vals += "======= ServerVariables ======= \r\n";
			keys = HttpContext.Current.Request.ServerVariables.AllKeys;
			foreach (string key in keys)
			{
				vals += key + ": \t " + HttpContext.Current.Request.ServerVariables[key] + "\r\n";
			}


			vals += "\r\n\r\n\r\n";

			vals += "========= Headers ======= \r\n";
			keys = HttpContext.Current.Request.Headers.AllKeys;
			foreach (string key in keys)
			{
				vals += key + ": \t " + HttpContext.Current.Request.Headers[key] + "\r\n";
			}

			vals += "\r\n\r\n\r\n";


			System.IO.StreamWriter fs = null;
			try
			{
				string filePath = HttpContext.Current.Request.PhysicalApplicationPath + "App_Data\\" + DateTime.Now.Ticks + "_" + gatewayName + ".txt";
				fs = new System.IO.StreamWriter(filePath);
				fs.Write(vals);
			}
			catch
			{
			}
			finally
			{
				if (fs != null)
				{
					fs.Flush();
					fs.Close();
				}

			}
		}
	}
}