﻿
/*
version 3.1   2006-11-04 22:46

TESTED with: IE 6, Firefox 1.5, Opera 9.02

works with any DOCTYPE, BUT THE BEST PERFORMACNE ACHIEVED WITH:
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">


INSTALLATION: add next line at the end of an html file (after closing </html> tag):

<script id="debugger" type="text/javascript" src="debugger.js"></script>

*/


var objarray = new Array();
var mousex = 50;
var mousey = 50;
var szindex = 100;
var dragging = false;
var xdif = 0;
var ydif = 0;
var obdiv = null; //element to drag
var sorted = true; // default value


function debug(object, property, owner)
{
	if(object == null) return;
	
	var title = "";
	//title format:  owner.property : (object|value)
	if(owner && owner.nodeName)
	{
		title += owner.nodeName + ".";
	}
	if(property)
	{
		title += property + " : ";
	}
	if((title == "") && object.nodeName)
	{
		title = object.nodeName;
	}
	
	var objn = objarray.length;
	objarray[objn] = object;

	strout = 
	"<table id='debugtable' cellpadding='0' cellspacing='2px' border='0' style='font: Arial; font-size:10px; font-family: Verdana;" +
		" border:2px solid purple; background-color:whitesmoke;'>" +
	//row one, title
	"<tr id='debugtr' style='font-weight:bold; color:White; '>" +
		"<td id='debugtd' style='cursor:pointer;height:10px; width:10px; background-color:blue;padding:5px' onclick='closediv(this)'>X</td>" +
		"<td id='debugtd' colspan='2' onmousedown='getdivtodrag(this, event)' style='cursor:move; background-color:red;padding:5px; '>" + 
			title + "</td>" + 
	"</tr>";
	if(object.nodeName)
	{
		strout += 
			//row two, node name
			"<tr id='debugtr'>" +
				"<td id='debugtd'></td>" +
				"<td id='debugtd' style='padding-left:5px; padding-right:10px; height:5px;'>nodeName : </td>" +
				"<td id='debugtd'><strong> " + object.nodeName + "</strong></td>" +
			"</tr>" +
			//row three, node id
			"<tr id='debugtr'>" +
				"<td id='debugtd'></td>" +
				"<td id='debugtd' style='padding-left:5px; padding-right:10px; height:5px;'>ID : </td>" +
				"<td id='debugtd'><strong> " + object.id + "</strong></td>" +
			"</tr>" ;
	}
	else
	{
		strout += 
			//row two, node name
			"<tr id='debugtr'>" +
				"<td id='debugtd'></td>" +
				"<td id='debugtd' style='padding-left:5px; padding-right:10px; height:5px;'></td>" +
				"<td id='debugtd'><strong> " + object + "</strong></td>" +
			"</tr>";
	}
	//row
	strout += 
		"<tr id='debugtr'>" +
			"<td id='debugtd' colspan='3' style='height:2px; background-color:white'></td>" +
		"</tr>";
	
	var count = 0;
	var color = "white";
	var btncolor = "white";
	var tmpvalue;
	
	var arProps = new Array();
	//get all object's properties and place them to arProps
	for(prop in object)
	{
		arProps.push(prop);
	}
	if(sorted) //if you want to sort properties place true
	{
		arProps.sort();
	}
	var arlen = arProps.length;
	for(var nn = 0; nn < arlen; nn++)
	{
		var el = arProps[nn];
		
		if(((count++) % 2) == 0)
		{
			btncolor = color = "white";
		}
		else
		{
			btncolor = color = "whitesmoke";
		}
		
		try
		{
			tmpvalue = object[el];
		}
		catch(e){}
		
		if(el.toLowerCase() == "innerhtml") tmpvalue = "* not showing *";
		if(el.toLowerCase() == "innertext") tmpvalue = "* not showing *";
		if(el.toLowerCase() == "outerhtml") tmpvalue = "* not showing *";
		if(el.toLowerCase() == "outertext") tmpvalue = "* not showing *";
		if(el.toLowerCase() == "text") tmpvalue = "* not showing *";
		if(el.toLowerCase() == "textcontent") tmpvalue = "* not showing *";
		 
		try
		{ 
			for(inerprop in tmpvalue)
			{
				btncolor = "red";
				if(tmpvalue.nodeName)
				{
					tmpvalue = tmpvalue + " : <strong>" + tmpvalue.nodeName + "</strong>";
				}
				break;
			}
		}
		catch(e){}			
		strout += 
		"<tr style='background-color:" + color + "'>" +
			"<td style=' background-color:" + btncolor + "'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>" +
			"<td onclick=\"debugprop(this, " + objn + ")\" style='padding-left:5px; padding-right:10px; height:5px;cursor:pointer'>" + 
				el + "</td><td style='padding-left:5px; padding-right:10px;'>" + tmpvalue + "</td>" +
		"</tr>";		
	}
	strout += "</table><br/>";
	
	var mydiv = document.createElement("div");
	var body = document.getElementsByTagName("body")[0];
	if(!body)
	{
		alert("document has no body tag");
		return;
	}
	var ohtml = document.getElementsByTagName("html")[0];
	if(!ohtml)
	{
		alert("document has no HTML tag");
		return;
	}
	var scrollLeft, scrollTop;

	if((window.opera))
	{
		//doctype HTML 4.0 or no doctype
		scrollLeft = body.scrollLeft;
		scrollTop = body.scrollTop;
	}
	else
	{
		//doctype XHTML 1.0 
		scrollLeft = ohtml.scrollLeft;
		scrollTop = ohtml.scrollTop;
	}
	mydiv.innerHTML = strout;
	strout = "";
//	mydiv.style.border = "solid 2px purple";	
	mydiv.style.position = "absolute";
	mydiv.style.left = (mousex + scrollLeft) + "px";
	mydiv.style.top = (mousey + scrollTop) + "px";
	mydiv.style.zIndex = ++szindex;
	
	mydiv.id = "debuggingdiv" + objn;
	
	body.appendChild(mydiv);
	
}	
 
function closediv(elem)
{
	var divremove = elem.parentNode.parentNode.parentNode.parentNode;
	divremove.parentNode.removeChild(divremove);
	divremove = null;
	mousex = mousey = 50;
}
function debugprop(elem, currentobjn)
{	
	//debug(object|value, property, ownerobject)
	var owner = objarray[currentobjn];
	var property = elem.innerHTML;
	var object = owner[property];
	debug(object, property, owner);
}


function getmousepos(divevent)
{
	mousex = divevent.clientX;
	mousey = divevent.clientY;
}
function getdivtodrag(elem, evnt) //onmousedown
{
	var dragelem = elem.parentNode.parentNode.parentNode.parentNode;
	startdrag(dragelem, evnt);
}

function startdrag(elemtodrag, evnt)
{	
	//obdiv = element to drag
	obdiv = elemtodrag;

	elemtodrag.style.zIndex = ++szindex;

	xdif = parseInt( evnt.clientX) - parseInt(obdiv.style.left);
	ydif = parseInt( evnt.clientY) - parseInt(obdiv.style.top);

	dragging = true;
		
}

function drag(ev) //onmousemove
{
	if(dragging)
	{
		obdiv.style.left = (parseInt(ev.clientX) - xdif) + "px";
		obdiv.style.top = (parseInt(ev.clientY) - ydif) + "px";
	}
}
function stopdrag() //onmouseup
{
	if(dragging)
	{
		dragging = false;
	}		
}


////////////////////////////////////////////////////////////////
//watch routine is not finished
initwatch();

var watcharea0;
var watcharea1;
var watcharea2;
var watcharea3;

function closewatch(elem)
{
	var divremove = elem.parentNode.parentNode.parentNode.parentNode;
	divremove.parentNode.removeChild(divremove);
	divremove = null;
	mousex = mousey = 50;
	//set cookie
	document.cookie = "ShowWatchWin=false" ;
}
	
function getshowfromcookie()
{
	var indx = document.cookie.indexOf("ShowWatchWin=");
	var value = "";
	if(indx >= 0)
	{
		value = document.cookie.substr(indx + 13, 4);
	}
	else
	{
		document.cookie = "ShowWatchWin=true" ;
		value = "true";
	}
	return value;
}

function initwatch()
{
	if(getshowfromcookie() == "true")
	{
		showwatch();
	}
	
}
function showwatch()
{
	var mydiv = document.createElement("div");
	var body = document.getElementsByTagName("body")[0];
	if(body)
	{
		body.appendChild(mydiv);
	}
	else
	{
		alert("no body!\nbe sure to include 'debugger.js' at the bottom of the html file");
		return;
	}
	
	strout = "";
	//mydiv.style.border = "solid 5px blue";	
	mydiv.style.position = "absolute";
	mydiv.style.left = mousex + "px";
	mydiv.style.top = mousey + "px";
	mydiv.style.zIndex = ++szindex;//
	mydiv.id = "watchdiv0";
	mydiv.style.border = "2px solid green";
	
	mydiv.innerHTML = 	
		"<table id='watctable' cellpadding='0' cellspacing='2px' border='0' style='font: Arial; font-size:10px; font-family:Verdana; background-color:whitesmoke;'>" +
	//row one, title
	"<tr id='watchtr' style='font-weight:bold; color:White; '>" +
		"<td id='watchtd' style='cursor:pointer;height:10px; width:10px; background-color:blue;padding:5px;' onclick='closewatch(this)'>X</td>" +
		"<td id='watchtd' colspan='2' onmousedown='getdivtodrag(this, event)' style='cursor:move; background-color:red;padding:5px; '>watch</td>" + 
	"</tr>" +
	"<tr id='watchtr'><td id='watchtd'>&nbsp;</td><td colspan='2' id='watcharea0' style='padding:5px;'></td></tr>" +
	"<tr id='watchtr'><td id='watchtd'>&nbsp;</td><td id='watchtd' style='padding:5px'>nodeName<br/>ID</td><td id='watcharea1a' style='padding:5px;'></td></tr>" +
	"<tr id='watchtr'><td id='watchtd'>&nbsp;</td><td id='watcharea2a' colspan='2' style='padding:5px 5px 0 5px'></td></tr>" +
	"<tr id='watchtr'><td id='watchtd'>&nbsp;</td><td id='watcharea3a' colspan='2' style='padding:0 5px 5px 5px'></td></tr>" +
	"</table>";
	
	watcharea0 = document.getElementById("watcharea0");
	watcharea1 = document.getElementById("watcharea1a");
	watcharea2 = document.getElementById("watcharea2a");
	watcharea3 = document.getElementById("watcharea3a");
	
	
	watcharea0.innerHTML = "<div><input id='chkDbgSortType' type='checkbox' onclick='sortchanged(this)' >Sort alphabetically</input></div>" +
				"<div><input  type='button' value='debug selected' onclick='invoke()' style='height:30px' /></div>" +
				"<div>SHIFT + mouse to select</div>" ;
	document.getElementById("chkDbgSortType").checked = this.sorted;
	/////////////////////////////////////////
	if(document.attachEvent)
	{
		document.attachEvent("onmousemove", mousemoving);
		document.attachEvent("onmouseup", stopdrag);
	}
	else if(document.addEventListener)
	{
		document.addEventListener("mousemove", mousemoving, true);
		document.addEventListener("mouseup", stopdrag, true);
	}	
	
}

function sortchanged(obj)
{
	sorted = obj.checked;
}

function invoke()
{
	if(srcelem)
	{
		debug(srcelem);
	}
}

var srcelem;
function mousemoving(myevent)
{
	getmousepos(myevent);
	
	drag(myevent);
	
	if(myevent.shiftKey)
	{
		watcharea2.innerHTML = "event.clientX: " + myevent.clientX;
		watcharea3.innerHTML = "event.clientY: " + myevent.clientY;
		
		if(myevent.srcElement)
		{	
			srcelem = myevent.srcElement;
		}
		else if(myevent.target)
		{
			srcelem = myevent.target;
		}
		watcharea1.innerHTML =	"<b>" + srcelem.nodeName + "</b>&nbsp;<br/>" +
								srcelem.id + "&nbsp;";
	}
}