using System;
using System.Data;
using Imf.Cart.CartAppCode;
using System.Web.UI.WebControls;
using System.Text;

public partial class DynamicPage : System.Web.UI.Page
{
	protected string siteRoot = Root.GetSiteRoot();

	protected string allProdsLinks = "";

	protected void Page_Load(object sender, EventArgs e)
	{
		if (!Page.IsPostBack)
		{
			string pageName = Request.QueryString["p"];
			string categoryId = Request.QueryString["catid"];

			if (pageName != null)
			{
				MultiView1.SetActiveView(View1); //dynamic html view
				LoadDynamicHtml(pageName);
			}
			else if (categoryId != null)
			{
				MultiView1.SetActiveView(View2); //productslist view
				LoadProductsList(categoryId);
			}
			else
			{
				MultiView1.SetActiveView(View2); //productslist view
				LoadProductsList(hdnDefaultCategory.Value);  //get default category list

				// GET ALL PRODUCTS LINKS - SEO OPTIMIZATION
				// place links to all products on the default.aspx page for search engines to index all products
				DataTable dtAllProds = ProductsProvider.GetActiveProductsLinksFromCacheOrDB();
				StringBuilder sb = new StringBuilder();
				foreach (DataRow dr in dtAllProds.Rows)
				{
					sb.Append("<a href=\"" + siteRoot + "/productpage.aspx?pid=" + dr["ProductID"] + "\" >" + dr["ProductName"] + "</a>");
				}
				allProdsLinks = sb + "";

			}
		}

	}
	protected void LoadDynamicHtml(string pageName)
	{
		if (pageName != "")
		{
			// DYNAMIC HTML CONTENT
			DynamicHtml dynpage = null;
			DynamicHtml.GetPage(pageName, ref dynpage);
			if (dynpage.isActive)
			{
				ltrHtml.Text = dynpage.html;
				Page.Title = dynpage.pageTitle;
				if (Page.Title == "")
				{
					Page.Title = dynpage.name;
				}
				////////////////////////////////////////////////////////////////////////////////////////////////
				//META INFO
				hdnMetaKeywords.Value = dynpage.metaKeywords;
				hdnMetaDescription.Value = dynpage.metaDescription;
				// CONTENT TITLE
				hdnContentTitle.Value = dynpage.contentTitle;
				///////////////////////////////////////////////////////////////////////////////////////////////
			}
		}
	}




	protected void LoadProductsList(string categoryId)
	{
		int icatid = 0;
		int.TryParse(categoryId, out icatid);

		DataTable dt = null;
		if (icatid > 0)
		{
			//get all categories
			DataTable dtCat = CategoriesProvider.GetAllCategoriesFromCacheOrDB();
			foreach (DataRow drcat in dtCat.Rows)
			{
				if ((int)drcat["CategoryID"] == icatid)
				{
					Page.Title = drcat["PageTitle"] + "";
					if (Page.Title == "")
					{
						Page.Title = drcat["CategoryName"] + "";
					}
					////////////////////////////////////////////////////////////////////////////////////////////////
					// META INFO
					hdnMetaKeywords.Value = drcat["MetaKeywords"] + "";
					hdnMetaDescription.Value = drcat["MetaDescription"] + "";
					// CONTENT TITLE
					hdnContentTitle.Value = drcat["ContentTitle"] + "";
					///////////////////////////////////////////////////////////////////////////////////////////////

					break;  //exit the foreach loop
				}
			}

			// get active products by category
			dt = (DataTable)Cache["dt_prodlist_cat_" + icatid];
			if (dt == null)
			{
				dt = ProductsProvider.GetProductsByCategory(icatid, true).Tables[0];
				Cache["dt_prodlist_cat_" + icatid] = dt;
			}
		}
		Repeater1.DataSource = dt;
		Repeater1.DataBind();

		//    //////////////////////////////////////////////////////////////////////////////////////
		//    Response.Cache.SetCacheability(System.Web.HttpCacheability.ServerAndNoCache);
		//    Response.Cache.SetValidUntilExpires(true);
		//    //////Response.Cache.SetNoStore();
		//    Response.Cache.SetExpires(DateTime.Now.AddHours(6));
		//    //////Response.BufferOutput = false;
		//    Response.Cache.VaryByParams["*"] = true;
		//    //////////////////////////////////////////////////////////////////////////////////////
	}

	protected string GetPrice(object oSalePrice, object oOldPrice)
	{
		double dSalePrice = double.Parse(oSalePrice.ToString());
		string sOut = "";
		double dOldPrice = double.Parse(oOldPrice.ToString());
		if (dSalePrice == 0)
		{
			sOut = "<span class=\"saleprice\">FREE</span>";

		}
		else if (dOldPrice > 0)
		{
			sOut = "<span class=\"oldprice\">" +
				AppSettingsProvider.CurrencySign +
				dOldPrice.ToString("n2") +
				"</span>&nbsp;&nbsp;<span class=\"saleprice\">" +
				AppSettingsProvider.CurrencySign +
				dSalePrice.ToString("n2") + "</span>";
		}
		else
		{
			sOut = "<span class=\"saleprice\">" + AppSettingsProvider.CurrencySign +
				dSalePrice.ToString("n2") + "</span>";

		}
		return sOut;
	}

	protected bool SetAddToCartVisible(object oUnitsInStock)
	{
		int iInStock = int.Parse(oUnitsInStock.ToString());
		if (iInStock > 0)
		{
			return true;
		}
		else
		{
			return false;
		}
	}

	protected bool GetVisible(object unitsinstock, object salePrice)
	{
		if (((int)unitsinstock > 0) && ((double)salePrice > 0))
		{
			return true;
		}
		else
		{
			return false;
		}
	}


}